"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SmallValues = exports.ReallySimple = exports.WithAudioURL = exports.SimpleTimeSeries = exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _ = _interopRequireDefault(require("./"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var _default = {
  title: "ReactTimeSeries",
  component: _.default
};
exports.default = _default;

var SimpleTimeSeries = function SimpleTimeSeries() {
  var _useState = (0, _react.useState)({
    timeData: [{
      time: 0,
      value: 0
    }, {
      time: 500,
      value: 1
    }, {
      time: 1000,
      value: 0
    }],
    annotation: {
      timestamps: [{
        time: 250,
        label: "example timestamp"
      }],
      durations: [{
        start: 0,
        end: 100,
        label: "example duration"
      }, {
        start: 200,
        end: 300,
        label: "example duration"
      }, {
        start: 800,
        end: 1000,
        label: "byeeee"
      }]
    }
  }),
      _useState2 = _slicedToArray(_useState, 2),
      sample = _useState2[0],
      setSample = _useState2[1];

  return /*#__PURE__*/_react.default.createElement(_.default, {
    interface: {},
    sample: sample,
    onModifySample: setSample
  });
};

exports.SimpleTimeSeries = SimpleTimeSeries;

var WithAudioURL = function WithAudioURL() {
  var _useState3 = (0, _react.useState)({
    audioUrl: "https://s3.amazonaws.com/datasets.workaround.online/voice-samples/001/voice.mp3"
  }),
      _useState4 = _slicedToArray(_useState3, 2),
      sample = _useState4[0],
      setSample = _useState4[1];

  return /*#__PURE__*/_react.default.createElement(_.default, {
    interface: {},
    sample: sample,
    onModifySample: setSample
  });
};

exports.WithAudioURL = WithAudioURL;

var ReallySimple = function ReallySimple() {
  return /*#__PURE__*/_react.default.createElement(_.default, {
    interface: {},
    sample: {
      timeData: [{
        time: 0,
        value: 0
      }, {
        time: 500,
        value: 500
      }, {
        time: 1000,
        value: 1000
      }]
    },
    onModifySample: function onModifySample() {
      return null;
    }
  });
};

exports.ReallySimple = ReallySimple;

var SmallValues = function SmallValues() {
  return /*#__PURE__*/_react.default.createElement(_.default, {
    interface: {
      timeFormat: "none"
    },
    sample: {
      timeData: [{
        time: 0,
        value: 0
      }, {
        time: 0.02,
        value: 500
      }, {
        time: 0.05,
        value: 1000
      }]
    },
    onModifySample: function onModifySample() {
      return null;
    }
  });
};

exports.SmallValues = SmallValues;