"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TimeWithTextMarkers = exports.TimeWithTimestamps = exports.Dates = exports.TimeWithColons = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _useColors = _interopRequireDefault(require("../../hooks/use-colors"));

var _ = _interopRequireDefault(require("./"));

var _getMinorMajorDurationLines = _interopRequireDefault(require("../../utils/get-minor-major-duration-lines"));

var _immutableTransformMatrix = _interopRequireDefault(require("immutable-transform-matrix"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var _default = {
  title: "Timeline",
  component: _.default,
  argTypes: {
    width: "number",
    onClickTimestamp: {
      action: "onClickTimestamp"
    }
  }
};
exports.default = _default;

var TimeWithColons = function TimeWithColons(args) {
  return /*#__PURE__*/_react.default.createElement(_.default, _extends({}, args, {
    timeFormat: "timecolons",
    width: 500,
    visibleTimeStart: 0,
    visibleTimeEnd: 60000 * 80,
    gridLineMetrics: (0, _getMinorMajorDurationLines.default)(new _immutableTransformMatrix.default(), 500)
  }));
};

exports.TimeWithColons = TimeWithColons;

var Dates = function Dates(args) {
  return /*#__PURE__*/_react.default.createElement(_.default, _extends({}, args, {
    timeFormat: "dates",
    width: 500,
    visibleTimeStart: 0,
    visibleTimeEnd: 60000 * 60 * 24 * 400,
    gridLineMetrics: (0, _getMinorMajorDurationLines.default)(new _immutableTransformMatrix.default(), 500)
  }));
};

exports.Dates = Dates;

var TimeWithTimestamps = function TimeWithTimestamps(args) {
  var colors = (0, _useColors.default)();
  return /*#__PURE__*/_react.default.createElement(_.default, _extends({}, args, {
    timeFormat: "timecolons",
    width: 500,
    visibleTimeStart: 0,
    visibleTimeEnd: 60000 * 80,
    timestamps: [{
      time: 10 * 60000,
      color: colors.cyan
    }, {
      time: 50 * 60000,
      color: colors.red
    }],
    gridLineMetrics: (0, _getMinorMajorDurationLines.default)(new _immutableTransformMatrix.default(), 500)
  }));
};

exports.TimeWithTimestamps = TimeWithTimestamps;

var TimeWithTextMarkers = function TimeWithTextMarkers(args) {
  var colors = (0, _useColors.default)();
  return /*#__PURE__*/_react.default.createElement(_.default, _extends({}, args, {
    timeFormat: "timecolons",
    width: 500,
    visibleTimeStart: 0,
    visibleTimeEnd: 60000 * 80,
    timestamps: [{
      time: 10 * 60000,
      color: colors.cyan,
      label: "Timestamp 1"
    }, {
      time: 50 * 60000,
      color: colors.red,
      label: "Another Timestamp"
    }],
    gridLineMetrics: (0, _getMinorMajorDurationLines.default)(new _immutableTransformMatrix.default(), 500)
  }));
};

exports.TimeWithTextMarkers = TimeWithTextMarkers;